# This package was forked from redhat-release-atomic-host.
%define debug_package %{nil}

# RHEL part
%define base_product_family Red Hat Enterprise Linux
%define base_release_version 7
%define full_release_version 7.2
%define dist_release_version 7
%define beta
%define dist .el%{dist_release_version}

# RHV variant part
%define product_family Red Hat Virtualization
%define product_family_concat RedHatVirtualization

%define variant_id ovirt-node
%define variant_titlecase Host
%define variant_titlecase_concat Host
%define variant_lowercase hypervisor
%define variant_full_release_version 4.0

%define release_pkg_version 4.2

Name:           redhat-release-virtualization-host
Version:        %{variant_full_release_version}
Release:        %{release_pkg_version}%{?dist}
Summary:        %{product_family} %{variant_titlecase} release file
Group:          System Environment/Base
License:        GPLv2

Provides:       redhat-release = %{full_release_version}
Provides:       system-release = %{full_release_version}
Provides:       system-release(releasever) = %{base_release_version}%{product_family_concat}%{?variant_titlecase_concat}

ExclusiveArch:  x86_64

# Use the complete source, to know where it came from
Source0:	redhat-gpg-keys-7.tar.gz
Source1:        http://git.app.eng.bos.redhat.com/git/rcm/rcm-metadata.git/plain/product_ids/rhvh-4.0/RHVH-x86_64-eb54946b6199-328.pem?id=1de07a06b4d14f32a208217dc3dbe20693f9d013#rhvh-4.0/RHVH-x86_64-eb54946b6199-328.pem
Source2:        logo.png
Source3:        bg-login.png
Source4:        branding.css
Source5:        favicon.ico
Source7:        98-ovirt-host-node.preset

%description
%{product_family} %{variant_titlecase} release files

%package -n redhat-virtualization-host-image-update-placeholder
Summary:        The RHV hypervisor Image Update Placeholder
Version:        %{variant_full_release_version}
Release:        %{release_pkg_version}%{?dist}
Group:          System Environment/Base
License:        GPLv2
URL:            http://www.ovirt.org
BuildArch:      noarch

%description -n redhat-virtualization-host-image-update-placeholder
A sub-package to be included into RHV-H Next squashfs
image to allow upgrading itself

%package content
Summary:	Dependencies for the RHV Hypervisor
Version:        %{variant_full_release_version}
Release:        %{release_pkg_version}%{?dist}
Summary:        %{product_family} %{variant_titlecase} release file
Group:          System Environment/Base
License:        GPLv2

# Requirements for RHEL installer
# Requirements for EFI
#
# Additional packages for EFI support
# https://www.brianlane.com/creating-live-isos-with-livemedia-creator.html
# http://lorax.readthedocs.org/en/latest/livemedia-creator.html#kickstarts
Requires:       efibootmgr
Requires:       grub2-efi
Requires:       memtest86+
Requires:       syslinux
Requires:       efibootmgr
Requires:       shim
# Anaconda in RHEL assumes that openscap is available,
# thus we need to include it as well.
# Bug-Url: https://bugzilla.redhat.com/show_bug.cgi?id=1331354
Requires:       openscap
Requires:       openscap-utils
Requires:       scap-security-guide

# Core RHV requirements
Requires:       imgbased
Requires:       ovirt-node-ng-nodectl
Requires:       vdsm
Requires:       ovirt-hosted-engine-setup
Requires:       cockpit-ovirt-dashboard
Requires:       firewalld
Requires:       glusterfs
Requires:       glusterfs-fuse
Requires:       glusterfs-rdma
Requires:       NetworkManager-config-server
Requires:       mailx
Requires:       postfix

# Additional RHV requirements
Requires:       virt-who
Requires:       iotop
Requires:       subscription-manager
Requires:       redhat-access-insights
Requires:       vdsm-hook-fcoe
Requires:	vdsm-hook-vhostmd
Requires:	vdsm-hook-openstacknet
Requires:	vdsm-hook-ethtool-options
Requires:	vdsm-hook-vmfex-dev

# Enable FIPS
Requires:	dracut-fips

# Requirements to enable services
Requires:	audit
Requires:	rsyslog
Requires(post): systemd

%description content
Dependencies for the RHV hypervisor to enable necessary services and pull in
RHV packages.

%prep
%setup -q -c -n redhat-release-virtualization-host-%{base_release_version}

%build
echo OK

%install
# create /etc
mkdir -p %{buildroot}/etc

mkdir -p %{buildroot}/etc/pki/product-default
cp %{SOURCE1} %{buildroot}/etc/pki/product-default/328.pem

install -dDm 0755 %{buildroot}/%{_prefix}/share/redhat-release-virtualization-host/branding/
install -Dm 0644 %{SOURCE2} %{buildroot}/%{_prefix}/share/redhat-release-virtualization-host/branding/
install -Dm 0644 %{SOURCE3} %{buildroot}/%{_prefix}/share/redhat-release-virtualization-host/branding/
install -Dm 0644 %{SOURCE4} %{buildroot}/%{_prefix}/share/redhat-release-virtualization-host/branding/
install -Dm 0644 %{SOURCE5} %{buildroot}/%{_prefix}/share/redhat-release-virtualization-host/branding/

install -dDm 0755 %{buildroot}/%{_prefix}/lib/systemd/system-preset
install -Dm 0644 %{SOURCE7} %{buildroot}/%{_prefix}/lib/systemd/system-preset/

# combine GPG keys
cat RPM-GPG-KEY-redhat-release-2 RPM-GPG-KEY-redhat-auxiliary > RPM-GPG-KEY-redhat-release
rm RPM-GPG-KEY-redhat-release-2 RPM-GPG-KEY-redhat-auxiliary
cat RPM-GPG-KEY-redhat-beta-2 RPM-GPG-KEY-redhat-legacy-beta > RPM-GPG-KEY-redhat-beta
rm RPM-GPG-KEY-redhat-beta-2 RPM-GPG-KEY-redhat-legacy-beta

# copy GPG keys
mkdir -p -m 755 %{buildroot}/etc/pki/rpm-gpg
for file in RPM-GPG-KEY* ; do
    install -m 644 $file %{buildroot}/etc/pki/rpm-gpg
done

# create /etc/system-release and /etc/redhat-release
echo "%{base_product_family} release %{full_release_version}" > %{buildroot}/etc/redhat-release
ln -s redhat-release %{buildroot}/etc/system-release

# create /etc/os-release
mkdir -p %{buildroot}/usr/lib/os.release.d/
cat << EOF >>%{buildroot}/usr/lib/os.release.d/os-release-rhv-host
NAME="%{base_product_family}"
VERSION="%{full_release_version}"
VERSION_ID="%{full_release_version}"
ID="rhel"
ID_LIKE="fedora"
VARIANT="%{?product_family} %{?variant_titlecase}"
VARIANT_ID="%{?variant_id}"
PRETTY_NAME="%{product_family} %{variant_titlecase} %{variant_full_release_version} (el%{full_release_version})"
ANSI_COLOR="0;31"
CPE_NAME="cpe:/o:redhat:enterprise_linux:%{full_release_version}:%{?beta:beta}%{!?beta:GA}%{?variant_lowercase::%{variant_lowercase}}"
HOME_URL="https://www.redhat.com/"
BUG_REPORT_URL="https://bugzilla.redhat.com/"

# FIXME
REDHAT_BUGZILLA_PRODUCT="%{product_family}"
REDHAT_BUGZILLA_PRODUCT_VERSION=%{full_release_version}
REDHAT_SUPPORT_PRODUCT="%{product_family}"
REDHAT_SUPPORT_PRODUCT_VERSION=%{full_release_version}
EOF

ln -s ../usr/lib/os-release %{buildroot}/etc/os-release
ln -s os.release.d/os-release-rhv-host %{buildroot}/usr/lib/os-release

# write cpe to /etc/system/release-cpe
echo "cpe:/o:redhat:enterprise_linux:%{full_release_version}:%{?beta:beta}%{!?beta:GA}%{?variant_lowercase::%{variant_lowercase}}" | tr [A-Z] [a-z] > %{buildroot}/etc/system-release-cpe

# create /etc/issue and /etc/issue.net
echo '\S' > %{buildroot}/etc/issue
echo 'Kernel \r on an \m' >> %{buildroot}/etc/issue
cp %{buildroot}/etc/issue %{buildroot}/etc/issue.net
echo >> %{buildroot}/etc/issue

# FIXME is this relevant for RHVH?
# https://bugzilla.redhat.com/show_bug.cgi?id=1204194
#mkdir -p %{buildroot}/etc/systemd/system
#ln -s /dev/null %{buildroot}/etc/systemd/system/brandbot.path

%post content
systemctl enable cockpit.socket
systemctl enable sshd.service
systemctl enable auditd.service
systemctl enable rsyslog.service
systemctl enable imgbase-clean-grub.service
systemctl enable imgbase-motd.service
systemctl enable NetworkManager.service

# Mask brandbot for rhbz#1355727
systemctl mask brandbot.path

firewall-offline-cmd --add-service=cockpit >/dev/null 2>&1
firewall-offline-cmd --add-service=vdsm >/dev/null 2>&1
firewall-offline-cmd --add-service=libvirt >/dev/null 2>&1
firewall-offline-cmd --add-service=ssh >/dev/null 2>&1
systemctl restart firewalld.service >/dev/null 2>&1

# Only on installation
if [ $1 = 1 ]; then
    # FIXME: Nothing owns /etc/pki/product/69.pem. How does it get there?
    rm /etc/pki/product/69.pem
    source /etc/os-release
    ln -sf %{_prefix}/share/redhat-release-virtualization-host/branding %{_prefix}/share/cockpit/branding/$ID-ovirt-node
fi

systemctl restart cockpit.service >/dev/null 2>&1

#
# NGN TEMPORARY HACKS
# For each hack there must be a bug, and they must be removed at
# some point in time
# ===================

# Really ensure that myhostname is added
# https://bugzilla.redhat.com/show_bug.cgi?id=132994
sed -i.bak_ngn -e '
/^hosts:/ !b
/\<myhostname\>/ b
s/[[:blank:]]*$/ myhostname/
' /etc/nsswitch.conf

# Disable NM support on NGN
# 1. First we enabled
# https://bugzilla.redhat.com/show_bug.cgi?id=1330144
# which caused bugs
# 2. We disabled
# https://bugzilla.redhat.com/show_bug.cgi?id=1364126
mkdir -p %{_sysconfdir}/ovirt-host-deploy.conf.d
cat <<EOF > %{_sysconfdir}/ovirt-host-deploy.conf.d/90-ngn-do-not-keep-networkmanager.conf
[environment:init]
VDSM/disableNetworkManager=bool:True
EOF
mkdir -p %{_sysconfdir}/NetworkManager/conf.d
cat <<EOF > %{_sysconfdir}/NetworkManager/conf.d/90-ngn-do-not-handle-dns.conf
[main]
dns=none
EOF

# Hack out NM check in he-setup
# https://bugzilla.redhat.com/show_bug.cgi?id=1326798
sed -i -e "/def _check_NM/ s/$/\n        return/" \
  /usr/share/ovirt-hosted-engine-setup/plugins/gr-he-common/network/bridge.py

# Hack to disable the networkmanager page in cockpit
# https://bugzilla.redhat.com/show_bug.cgi?id=1367669
mv /usr/share/cockpit/network/manifest.json \
   /usr/share/cockpit/network/manifest.json_disabled_rhbz1367669

# =======================
# NGN TEMPORARY HACKS END
#

%files -n redhat-virtualization-host-image-update-placeholder

%files content

%files
%dir %{_prefix}/share/redhat-release-virtualization-host
%dir %{_prefix}/share/redhat-release-virtualization-host/branding
%config(noreplace) /etc/issue
%config(noreplace) /etc/issue.net
%config /etc/os-release
%config /etc/system-release
%config /etc/system-release-cpe
%config /etc/redhat-release
/etc/pki/rpm-gpg
%{_sysconfdir}/pki/product-default/328.pem
%{_prefix}/lib/systemd/system-preset/*
%{_prefix}/share/redhat-release-virtualization-host/branding/logo.png
%{_prefix}/share/redhat-release-virtualization-host/branding/bg-login.png
%{_prefix}/share/redhat-release-virtualization-host/branding/favicon.ico
%{_prefix}/share/redhat-release-virtualization-host/branding/branding.css
%{_prefix}/lib/systemd/system-preset/98-ovirt-host-node.preset
%{_prefix}/lib/os.release.d/os-release-rhv-host
%{_prefix}/lib/os-release


%changelog
* Fri Sep 16 2016 Ryan Barry <rbarry@redhat.com> - 4.0-4.2.el7
- Enable imgbased-clean-grub

* Thu Sep 15 2016 Ryan Barry <rbarry@redhat.com> - 4.0-4.1.el7
- Require ovirt-node-ng-nodectl instead of nodectl

* Tue Sep 6 2016 Ryan Barry <rbarry@redhat.com> - 4.0-3.el7
- Move dependencies to a subpackage to break depsolving loops

* Wed Aug 17 2016 Fabian Deutsch <fdeutsch@redhat.com> - 4.0-2.el7
- Disable NetworkManager tab in COckpit rhbz#1367669

* Tue Aug 16 2016 Ryan Barry <rbarry@redhat.com> - 4.0-1.1.el7
- Remove NM masking

* Thu Aug 11 2016 Fabian Deutsch <fdeutsch@redhat.com> - 4.0.1.el7
- Add NM masking
- Update he-setup bridge path

* Tue Aug 09 2016 Fabian Deutsch <fdeutsch@redhat.com> - 4.0-0.29.el7
- Remove beta
- Use disableNetworkManager=bool:True

* Wed Aug 3 2016 Ryan Barry <rbarry@redhat.com> - 4.0-0.26.el7
- Remove ovirt-node-ng-image-update-placeholder -- better method found

* Tue Aug 2 2016 Ryan Barry <rbarry@redhat.com> - 4.0-0.25.el7
- Pull anaconda-branding (it's now redhat-virtualization-host-productimg)
- Mask brandbot
- Add the EL version to os-release

* Fri Jul 29 2016 Ryan Barry <rbarry@redhat.com> - 4.0-0.24.el7
- Break the dependency on redhat-logos for anaconda-branding

* Thu Jul 28 2016 Ryan Barry <rbarry@redhat.com> - 4.0-0.23.el7
- Add ovirt-node-ng-image-update-placeholder without mutual
  dependencies
- Move anaconda branding to a product.img instead

* Wed Jul 27 2016 Ryan Barry <rbarry@redhat.com> - 4.0-0.22.el7
- Remove ovirt-node-ng-image-update-placeholder

* Wed Jul 27 2016 Ryan Barry <rbarry@redhat.com> - 4.0-0.21.el7
- Add vdsm-hook-vhostmd back now that it's build
- Add a package for ovirt-node-ng-image-update-placeholder in
  order to enable upgrades from engine
- Add a sidebar logo for anaconda

* Thu Jul 14 2016 Ryan Barry <rbarry@redhat.com> - 4.0-0.20.el7
- Fix certificate

* Thu Jul 14 2016 Ryan Barry <rbarry@redhat.com> - 4.0-0.19.el7
- Enable imgbase-motd
- Add GPG keys

* Wed Jul 13 2016 Ryan Barry <rbarry@redhat.com> - 4.0-0.18.el7
- Fix a typo in the package requirements

* Tue Jul 12 2016 Ryan Barry <rbarry@redhat.com> - 4.0-0.17.el7
- Require auditd and rsyslog so we can enable them

* Tue Jul 12 2016 Ryan Barry <rbarry@redhat.com> - 4.0-0.16.el7
- New certificate
- Final rebranding changes

* Mon Jul 11 2016 Ryan Barry <rbarry@redhat.com> - 4.0-0.15.el7
- Drop vdsm-hook-vhostmd until it's built

* Mon Jul 11 2016 Ryan Barry <rbarry@redhat.com> - 4.0-0.14.el7
- Require vdsm hooks
- Start auditd and rsyslog on boot

* Fri Jul 8 2016 Ryan Barry <rbarry@redhat.com> - 4.0-0.13.el7
- Require nodectl

* Thu Jul 7 2016 Ryan Barry <rbarry@redhat.com> - 4.0-0.12.el7
- Add anaconda-branding

* Thu Jul 7 2016 Ryan Barry <rbarry@redhat.com> - 4.0-0.11.el7
- Require dracut-fips

* Thu Jul 7 2016 Ryan Barry <rbarry@redhat.com> - 4.0-0.10.el7
- Rebrand visible strings

* Fri Jul 1 2016 Ryan Barry <rbarry@redhat.com> - 4.0-0.9.el7
- Remove vdsm-hook-fcoe until it works

* Fri Jun 17 2016 Ryan Barry <rbarry@redhat.com> - 4.0-0.8.el7
- Don't include "Beta" in system-release/redhat-release
- Require vdsm-hook-fcoe

* Wed Jun 08 2016 Fabian Deutsch <fdeutsch@redhat.com> - 4.0-0.7.el7
- Relocate product certificate
- Add product certificate
- Move to Beta

* Tue May 24 2016 Ryan Barry <rbarry@redhat.com> - 4.0-0.2.el7
- Merge in fixes from 3.6 to require packages, fix up services, etc

* Wed Mar 09 2016 Fabian Deutsch <fdeutsch@redhat.com> - 7.2-20160309.0.rhevh.el7
- Initial release
